# language: de
Funktionalität: Anlegen und Bearbeiten einer Wunschliste
   Als einfache nutzende Person
   um meine Wünsche festzuhalten
   möchte ich die Möglichkeit haben, eine bearbeitbare Wunschliste zu erhalten.

# zeilenweise benutzte Listen, beginnend mit Listennamen
    
Grundlage:
  Gegeben seien die folgenden Listen:
         | Basis           |       |       |      |      |      |      |      |
         | Eines           | Pony  |       |      |      |      |      |      |
         | Mehrere         | Hase  | PC    | Pony | Hase | Maus | PC   |      |
         | AnsEnde         | Hase  | PC    | Pony | Hase | Maus | PC   | Hund |
         | AmAnfang        | Hund  | Hase  | PC   | Pony | Hase | Maus | PC   |      
         | InMitte         | Hase  | PC    | Pony | Hund | Hase | Maus | PC   |
         | Sortiert        | Hase  | Hase  | Maus | PC   | PC   | Pony |      |
         | Reduziert       | Hase  | PC    | Pony | Maus |      |      |      |
         | DoppeltGelöscht | Hase  | PC    | Pony | Maus | PC   | Hund |      |
         | Vertauscht      | Hund  | PC    | Pony | Hase | Maus | PC   | Hase |
         | NachOben        | Hase  | Maus  | Hase | PC   | Pony | PC   |      |
         | NachUnten       | Hase  | Maus  | PC   | PC   | Pony | Hase |      |
         | MittigGeschoben | Hase  | Hase  | PC   | Pony | Maus | PC   |      |

Szenario: Wunschliste erstellen
  Wenn ich eine neue Wunschliste erstelle
  Dann erhalte ich die Liste "Basis" mit 0 Elementen
  
Szenario: Erster Wunsch
  Gegeben sei die Wunschliste "Basis"
  Wenn ich meinen Wunsch "Pony" hinzufüge
  Dann erhalte ich die Liste "Eines" mit 1 Elementen

Szenario: Neuer Wunsch ans Ende
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich meinen Wunsch "Hund" am Ende hinzufüge
  Dann erhalte ich die Liste "AnsEnde" mit 7 Elementen

Szenario: Neuer Wunsch an Anfang
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich meinen Wunsch "Hund" am Anfang hinzufüge
  Dann erhalte ich die Liste "AmAnfang" mit 7 Elementen

Szenario: Neuer Wunsch an beliebige Position
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich meinen Wunsch "Hund" an der Position 4 hinzufüge
  Dann erhalte ich die Liste "InMitte" mit 7 Elementen

Szenario: Neuer Wunsch an zu große Position
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich meinen Wunsch "Hund" an der Position 8 hinzufüge
  Dann erhalte ich die Liste "AnsEnde" mit 7 Elementen

Szenario: Neuer Wunsch an zu kleine Position
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich meinen Wunsch "Hund" an der Position 0 hinzufüge
  Dann erhalte ich die Liste "AmAnfang" mit 7 Elementen

Szenario: Wunschliste sortieren lassen
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich die Liste sortieren lasse
  Dann erhalte ich die Liste "Sortiert" mit 6 Elementen

Szenario: doppelte aus Wunschliste entfernen
  Gegeben sei die Wunschliste "Mehrere"
  Wenn ich doppelte aus der Liste entfernen lasse
  Dann erhalte ich die Liste "Reduziert" mit 4 Elementen

Szenario:  existierenden Wunsch löschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich den Wunsch "Hund" löschen lasse
  Dann erhalte ich die Liste "Mehrere" mit 6 Elementen

Szenario:  mehrfach existierenden Wunsch löschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich den Wunsch "Hase" löschen lasse
  Dann erhalte ich die Liste "DoppeltGelöscht" mit 6 Elementen

Szenario:  nicht existierenden Wunsch löschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich den Wunsch "Hose" löschen lasse
  Dann erhalte ich die Liste "AnsEnde" mit 7 Elementen

Szenario:  existierende Elemente vertauschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich die Wünsche an den Positionen 1 und 7 vertausche
  Dann erhalte ich die Liste "Vertauscht" mit 7 Elementen

Szenario:  nicht existierendes Element als Ausgangspunkt vertauschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich die Wünsche an den Positionen 8 und 7 vertausche
  Dann erhalte ich die Liste "AnsEnde" mit 7 Elementen

Szenario:  nicht existierendes Element als Endpunkt vertauschen
  Gegeben sei die Wunschliste "AnsEnde"
  Wenn ich die Wünsche an den Positionen 1 und 8 vertausche
  Dann erhalte ich die Liste "AnsEnde" mit 7 Elementen